/*
    Crystal Space Entity Layer
    Copyright (C) 2001 by Jorrit Tyberghein
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __CEL_BLTEST_BL__
#define __CEL_BLTEST_BL__

#include "iutil/comp.h"
#include "behaviourlayer/bl.h"

struct iObjectRegistry;
struct iCelEntity;

/**
 * This is the Behaviour Layer itself.
 */
class celBlTest : public iCelBlLayer
{
private:
  iObjectRegistry* object_reg;

public:
  celBlTest (iBase* parent);
  virtual ~celBlTest ();
  bool Initialize (iObjectRegistry* object_reg);

  SCF_DECLARE_IBASE;

  virtual const char* GetName () const { return "bltest"; }
  virtual iCelBehaviour* CreateBehaviour (iCelEntity* entity, const char* name);

  struct Component : public iComponent
  {
    SCF_DECLARE_EMBEDDED_IBASE (celBlTest);
    virtual bool Initialize (iObjectRegistry* p)
    { return scfParent->Initialize (p); }
  } scfiComponent;
};

#endif // __CEL_BLTEST_BL__

